from simudator.gui.module_graphics_item.register_graphic import (
    IntegerRegisterGraphicsItem,
)
from simudator.gui.orientation import Orientation
from simudator.gui.port_graphics_item import PortGraphicsItem


class SupcGraphicsItem(IntegerRegisterGraphicsItem):
    """
    Graphics module for mia's supc module.
    """

    def draw_graphics_item(self):
        self.draw_rect()

        width = (
            len(self.text.text()) * self._RECT_WIDTH_PER_CHAR + self._TEXT_WIDTH_MARGIN
        )

        # Draw to mPc port
        to_upc_port = PortGraphicsItem(
            self.module.signals["in_content"], Orientation.UP, parent=self
        )
        to_upc_port.setPos(width * 2 / 8, 0)
        self.ports.append(to_upc_port)

        # Draw from uPc port
        from_upc_port = PortGraphicsItem(
            self.module.signals["out_content"], Orientation.UP, parent=self
        )
        from_upc_port.setPos(width * 6 / 8, 0)
        self.ports.append(from_upc_port)
