from simudator.gui.module_graphics_item.register_graphic import (
    IntegerRegisterGraphicsItem,
)
from simudator.gui.orientation import Orientation
from simudator.gui.port_graphics_item import PortGraphicsItem


class uPcGraphicsItem(IntegerRegisterGraphicsItem):
    """
    Graphics module for mia's micro pc module.
    """

    def update(self):
        self.state = self.module.get_state()
        name = self.state["name"]
        value = self.state["value"]

        full_text = f"{name}: {value:02x}"

        self.text.setText(full_text)

    def draw_graphics_item(self):
        self.draw_rect()

        width = (
            len(self.text.text()) * self._RECT_WIDTH_PER_CHAR + self._TEXT_WIDTH_MARGIN
        )

        # Draw from K1 port
        from_k1 = PortGraphicsItem(self.module.signals["in_k1"], Orientation.UP, parent=self)
        from_k1.setPos(width * 2 / 8, 0)
        self.ports.append(from_k1)

        # Draw from K2 port
        from_k2 = PortGraphicsItem(self.module.signals["in_k2"], Orientation.UP, parent=self)
        from_k2.setPos(width * 6 / 8, 0)
        self.ports.append(from_k2)

        # Draw to SUPc port
        to_supc_port = PortGraphicsItem(
            self.module.signals["out_supc"], Orientation.DOWN, parent=self
        )
        to_supc_port.setPos(width * 2 / 8, self._RECT_HEIGHT)
        self.ports.append(to_supc_port)

        # Draw from SuPc port
        from_supc_port = PortGraphicsItem(
            self.module.signals["in_supc"], Orientation.DOWN, parent=self
        )
        from_supc_port.setPos(width * 6 / 8, self._RECT_HEIGHT)
        self.ports.append(from_supc_port)
