from simudator.core.module import Module
from simudator.core.processor import Processor

TEST_PATH = "test/test_core/processor_state_test.txt"


class Dummymodule(Module):
    def __init__(self, name):
        self.name = name
        self.string = None

    def load_from_str(self, state_string):
        self.string = state_string

    def get_string(self):
        return self.string

    def reset(self):
        self.string = ""

    def output_register(self):
        pass


def test_load_from_file():
    cpu = Processor()
    dummy1 = Dummymodule("PM1")
    dummy2 = Dummymodule("PM2")
    cpu.add_module(dummy1)
    cpu.add_module(dummy2)

    cpu.load_state_from_file(TEST_PATH)

    assert dummy1.get_string() == "00: 0001\n"
    assert dummy2.get_string() == "00: 0002\n01: 0003\n"
