from simudator.core.processor import Processor
from simudator.processor.mia.mia import MIA_CPU


def test_increment_10():
    cpu = MIA_CPU()
    cpu.load_state_from_file("mia_uppg3.txt")

    for itr in range(10000, 10):
        for _ in range(itr):
            cpu.do_tick()

        for i in range(itr, -1):
            cpu.load_cycle(i)


def test_max_undo():
    cpu = MIA_CPU()
    cpu.load_state_from_file("mia_uppg3.txt")
    max_undo = Processor.CYCLES_TO_SAVE

    for _ in range(2 * max_undo):
        cpu.do_tick()

    cpu.load_cycle(max_undo)


def test_do_50000_undo_one():
    cpu = MIA_CPU()
    cpu.load_state_from_file("mia_uppg3.txt")

    for _ in range(50000):
        cpu.do_tick()

    cpu.load_cycle(50000 - 1)
